#!/usr/bin/python

# This program is distributed under the GNU General Public License
# You are free to modify and distribute this source code under the terms of this license
# The full text of the GPL can be found at http://www.gnu.org/licenses/gpl.txt

import gobject
import gtk
import gtk.glade
import string
import os

def gtk_main_quit (*args):
	gtk.main_quit ()
	
def fill_os_info ():
	os_desc = gtk.glade.XML.get_widget (this_app,'os_info')
	try:
		fp = file ('/proc/version')
		lines = file.readlines (fp)
		file.close (fp)
	except IOError:
		lines = []
		
	info_str = ''
	for line in lines:
		info_str = info_str + line
	info_str = string.strip (info_str)
	
	info_field = gtk.TextBuffer ()
	info_field.set_text (info_str)
	
	os_desc.set_buffer (info_field)

def fill_host_name ():
	os_host = gtk.glade.XML.get_widget (this_app, 'host_name')
	fp = os.popen ('hostname')
	hostname = file.readline (fp)
	file.close (fp)
	hostname = string.strip (hostname)
	
	hostfield = gtk.TextBuffer ()
	hostfield.set_text (hostname)
	
	os_host.set_buffer (hostfield)
	
def fill_current_users ():
	users = gtk.glade.XML.get_widget (this_app, 'current_users')
	fp = os.popen ('users')
	curr_users = file.readline (fp)
	file.close (fp)
	curr_users = string.strip (curr_users)
	
	curr_users_field = gtk.TextBuffer ()
	curr_users_field.set_text (curr_users)
	
	users.set_buffer (curr_users_field)
	
def fill_uptime_info ():
	uptime = gtk.glade.XML.get_widget (this_app, 'uptime')
	fp = os.popen ('uptime')
	uptime_str = file.readline (fp)
	file.close (fp)
	uptime_str = string.strip (uptime_str)
	
	uptime_field = gtk.TextBuffer ()
	uptime_field.set_text (uptime_str)
	
	uptime.set_buffer (uptime_field)
	
def fill_modules_info ():
	moduletree = gtk.glade.XML.get_widget (this_app, 'modules')
	
	listmodules = gtk.ListStore (gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING)
	fp = os.popen ('lsmod')
	modules = file.readlines (fp)
	file.close (fp)
	i = 0
	for mod in modules:
		if (i != 0):
			mod = string.strip (mod)
			colarray = string.split (mod, None, 3)
			if (len(colarray) < 4):
				colarray.append ('')
			
			listmodules.append (colarray)
		i = i + 1
	
	cellrenderer1 = gtk.CellRendererText ()
	cellrenderer2 = gtk.CellRendererText ()
	cellrenderer3 = gtk.CellRendererText ()
	cellrenderer4 = gtk.CellRendererText ()
	
	lc1 = gtk.TreeViewColumn ('Module')
	lc1.set_resizable (True)
	lc1.pack_start (cellrenderer1)
	lc1.add_attribute (cellrenderer1, 'text', 0);
	
	lc2 = gtk.TreeViewColumn ('Size')
	lc2.set_resizable (True)
	lc2.pack_start (cellrenderer2)
	lc2.add_attribute (cellrenderer2, 'text', 1);
	
	lc3 = gtk.TreeViewColumn ('Used')
	lc3.set_resizable (True)
	lc3.pack_start (cellrenderer3)
	lc3.add_attribute (cellrenderer3, 'text', 2);
	
	lc4 = gtk.TreeViewColumn ('By')
	lc4.set_resizable (True)
	lc4.pack_start (cellrenderer3)
	lc4.add_attribute (cellrenderer3, 'text', 3);
	
	moduletree.set_model (listmodules)
	moduletree.append_column (lc1)
	moduletree.append_column (lc2)
	moduletree.append_column (lc3)
	moduletree.append_column (lc4)
	
def fill_env_info ():
	envtree = gtk.glade.XML.get_widget (this_app, 'environment')
	
	listenv = gtk.ListStore (gobject.TYPE_STRING, gobject.TYPE_STRING)
	
	for ele in os.environ:
		item = [ele, os.getenv(ele)]
		listenv.append (item)
	
	cell1 = gtk.CellRendererText ()
	cell2 = gtk.CellRendererText ()
	
	lc1 = gtk.TreeViewColumn ('Attribute')
	lc1.set_resizable (True)
	lc1.pack_start (cell1)
	lc1.add_attribute (cell1, 'text', 0)
	
	lc2 = gtk.TreeViewColumn ('Value')
	lc2.set_resizable (True)
	lc2.pack_start (cell2)
	lc2.add_attribute (cell2, 'text', 1)
	
	envtree.set_model (listenv)
	envtree.append_column (lc1)
	envtree.append_column (lc2)
	
def fill_cpu_info ():
	cputree = gtk.glade.XML.get_widget (this_app, 'cpuinfo')
	listcpuinfo = gtk.ListStore (gobject.TYPE_STRING, gobject.TYPE_STRING)
	
	try:
		fp = file ('/proc/cpuinfo')
		lines = file.readlines (fp)
		fp.close ()
	except IOError:
		lines = []
	
	for line in lines:
		line = string.strip (line)
		if (len(line) != 0):
			linearray = string.split (line, ':', 1)
			newlinearray = []
			for ele in linearray:
				ele = string.strip (ele)
				newlinearray.append (ele)
			listcpuinfo.append (newlinearray)
	
	cell1 = gtk.CellRendererText ()
	cell2 = gtk.CellRendererText ()
	
	lc1 = gtk.TreeViewColumn ('Attribute')
	lc1.set_resizable (True)
	lc1.pack_start (cell1)
	lc1.add_attribute (cell1, 'text', 0)
	
	lc2 = gtk.TreeViewColumn ('Value')
	lc2.set_resizable (True)
	lc2.pack_start (cell2)
	lc2.add_attribute (cell2, 'text', 1)
	
	cputree.set_model (listcpuinfo)
	cputree.append_column (lc1)
	cputree.append_column (lc2)

def fill_mem_info ():
	memtree = gtk.glade.XML.get_widget (this_app, 'meminfo')
	listmeminfo = gtk.ListStore (gobject.TYPE_STRING, gobject.TYPE_STRING)
	
	try:
		fp = file ('/proc/meminfo')
		lines = file.readlines (fp)
		file.close (fp)
	except IOError:
		lines = []
	
	for line in lines:
		line = string.strip (line)
		linearray = string.split (line, ':', 1)
		newlinearray = []
		for ele in linearray:
			ele = string.strip (ele)
			newlinearray.append (ele)
		listmeminfo.append (newlinearray)
	cell1 = gtk.CellRendererText ()
	cell2 = gtk.CellRendererText ()
	
	lc1 = gtk.TreeViewColumn ('Attribute')
	lc1.set_resizable (True)
	lc1.pack_start (cell1)
	lc1.add_attribute (cell1, 'text', 0)
	
	lc2 = gtk.TreeViewColumn ('Value')
	lc2.set_resizable (True)
	lc2.pack_start (cell2)
	lc2.add_attribute (cell2, 'text', 1)
	
	memtree.set_model (listmeminfo)
	memtree.append_column (lc1)
	memtree.append_column (lc2)
	
def fill_partition_info ():
	parttree = gtk.glade.XML.get_widget (this_app, 'partitions')
	listpartinfo = gtk.ListStore (gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING)
	
	try:
		fp = file ('/proc/partitions')
		lines = file.readlines (fp)
		file.close (fp)
	except IOError:
		lines = []
		
	i = 0
	for line in lines:
		if (i != 0):
			line = string.strip (line)
			linearray = string.split (line, None, 3)
			if (len(linearray) == 4):
				listpartinfo.append (linearray)
		i = i + 1
	
	cell1 = gtk.CellRendererText ()
	cell2 = gtk.CellRendererText ()
	cell3 = gtk.CellRendererText ()
	cell4 = gtk.CellRendererText ()
	
	lc1 = gtk.TreeViewColumn ('Major')
	lc1.set_resizable (True)
	lc1.pack_start (cell1)
	lc1.add_attribute (cell1, 'text', 0)
	
	lc2 = gtk.TreeViewColumn ('Minor')
	lc2.set_resizable (True)
	lc2.pack_start (cell2)
	lc2.add_attribute (cell2, 'text', 1)
	
	lc3 = gtk.TreeViewColumn ('# Blocks')
	lc3.set_resizable (True)
	lc3.pack_start (cell3)
	lc3.add_attribute (cell3, 'text', 2)
	
	lc4 = gtk.TreeViewColumn ('Name')
	lc4.set_resizable (True)
	lc4.pack_start (cell4)
	lc4.add_attribute (cell4, 'text', 3)
	
	parttree.set_model (listpartinfo)
	parttree.append_column (lc1)
	parttree.append_column (lc2)
	parttree.append_column (lc3)
	parttree.append_column (lc4)
	
def fill_mtab_info ():
	mtabtree = gtk.glade.XML.get_widget (this_app, 'mounttab')
	listmtabinfo = gtk.ListStore (gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING)
	
	try:
		fp = file ('/etc/mtab')
		lines = file.readlines (fp)
		file.close (fp)
	except IOError:
		lines = []
	
	for line in lines:
		line = string.strip (line)
		linearray = string.split (line, None, 5)
		listmtabinfo.append (linearray)
	
	cell1 = gtk.CellRendererText ()
	cell2 = gtk.CellRendererText ()
	cell3 = gtk.CellRendererText ()
	cell4 = gtk.CellRendererText ()
	cell5 = gtk.CellRendererText ()
	cell6 = gtk.CellRendererText ()
	
	lc1 = gtk.TreeViewColumn ('Device')
	lc1.set_resizable (True)
	lc1.pack_start (cell1)
	lc1.add_attribute (cell1, 'text', 0)
	
	lc2 = gtk.TreeViewColumn ('Mount point')
	lc2.set_resizable (True)
	lc2.pack_start (cell2)
	lc2.add_attribute (cell2, 'text', 1)

	lc3 = gtk.TreeViewColumn ('Filesystem')
	lc3.set_resizable (True)
	lc3.pack_start (cell3)
	lc3.add_attribute (cell3, 'text', 2)

	lc4 = gtk.TreeViewColumn ('Options')
	lc4.set_resizable (True)
	lc4.pack_start (cell4)
	lc4.add_attribute (cell4, 'text', 3)
	
	lc5 = gtk.TreeViewColumn ('Dump')
	lc5.set_resizable (True)
	lc5.pack_start (cell5)
	lc5.add_attribute (cell5, 'text', 4)
	
	lc6 = gtk.TreeViewColumn ('Pass')
	lc6.set_resizable (True)
	lc6.pack_start (cell6)
	lc6.add_attribute (cell6, 'text', 5)
	
	mtabtree.set_model (listmtabinfo)
	mtabtree.append_column (lc1)
	mtabtree.append_column (lc2)
	mtabtree.append_column (lc3)
	mtabtree.append_column (lc4)
	mtabtree.append_column (lc5)
	mtabtree.append_column (lc6)

def fill_pci_devices_info ():
	pcitree = gtk.glade.XML.get_widget (this_app, 'pcidevices')
	listpciinfo = gtk.ListStore (gobject.TYPE_STRING, gobject.TYPE_STRING)
	
	fp = os.popen ('lspci')
	lines = file.readlines (fp)
	file.close (fp)
	
	for line in lines:
		line = string.strip (line)
		linearray = string.split (line, ': ', 1)
		listpciinfo.append (linearray)
	
	cell1 = gtk.CellRendererText ()
	cell2 = gtk.CellRendererText ()
	
	lc1 = gtk.TreeViewColumn ('Device type')
	lc1.set_resizable (True)
	lc1.pack_start (cell1)
	lc1.add_attribute (cell1, 'text', 0)
	
	lc2 = gtk.TreeViewColumn ('Device name')
	lc2.set_resizable (True)
	lc2.pack_start (cell2)
	lc2.add_attribute (cell2, 'text', 1)
	
	pcitree.set_model (listpciinfo)
	pcitree.append_column (lc1)
	pcitree.append_column (lc2)
	
def fill_usb_devices_info ():
	usbinfoview = gtk.glade.XML.get_widget (this_app, 'usbdevices')
	
	fp = os.popen ('lsusb')
	info = file.readlines (fp)
	file.close (fp)
	
	infostr = ''
	for line in info:
		line = string.strip (line)
		infostr = infostr + line + '\n'
	
	usbtext = gtk.TextBuffer ()
	usbtext.set_text (infostr)
	
	usbinfoview.set_buffer (usbtext)
	
	
this_app = gtk.glade.XML ('genna.glade')
this_app.signal_autoconnect (locals())

fill_os_info ()
fill_host_name ()
fill_current_users ()
fill_uptime_info ()
fill_modules_info ()
fill_env_info ()
fill_cpu_info ()
fill_mem_info ()
fill_partition_info ()
fill_mtab_info ()
fill_pci_devices_info ()
fill_usb_devices_info ()

gtk.main ()
